"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
/**
 * The implementation for all viewable query operations of TAF tool.
*/
var BrowserView = /** @class */ (function () {
    function BrowserView() {
    }
    /**
     * Get the URL of a browser tab.
     */
    BrowserView.prototype.browserUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, browser.getUrl()];
                    case 1:
                        url = _a.sent();
                        return [2 /*return*/, url];
                }
            });
        });
    };
    /**
     * Get the current browser name.
    */
    BrowserView.prototype.browserName = function () {
        return __awaiter(this, void 0, void 0, function () {
            var browserName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, browser.capabilities.browserName];
                    case 1:
                        browserName = _a.sent();
                        return [2 /*return*/, browserName];
                }
            });
        });
    };
    /**
     * Wait for element on the screen and fetch and return its text.
     * @param locator Element locator as string, could be a CSS locator.
    */
    BrowserView.prototype.elementText = function (locator, scroll, timeout) {
        return __awaiter(this, void 0, void 0, function () {
            var element, elementText;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.waitForExist({ timeout: timeout * 1000 })];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, element.getText()];
                    case 3:
                        elementText = _a.sent();
                        return [2 /*return*/, elementText];
                }
            });
        });
    };
    /**
     * Getting the attribute value of an element.
     * @param locator Element locator as string, could be a CSS locator.
     * @param attributeName The name of the attribute.
    */
    BrowserView.prototype.getAttribute = function (locator, attributeName) {
        return __awaiter(this, void 0, void 0, function () {
            var element, attribute;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.getAttribute(attributeName)];
                    case 2:
                        attribute = _a.sent();
                        return [2 /*return*/, attribute];
                }
            });
        });
    };
    /**
     * Check if an element is currently displayed in the browser.
     * @param locator Element locator as string, could be a css locator.
    */
    BrowserView.prototype.elementIsVisible = function (locator) {
        return __awaiter(this, void 0, void 0, function () {
            var element, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.isDisplayed()];
                    case 2:
                        status = _a.sent();
                        return [2 /*return*/, status];
                }
            });
        });
    };
    /**
     * Get the invisible element status.
     * @param locator Element locator as string, could be a css locator.
    */
    BrowserView.prototype.elementIsInvisible = function (locator) {
        return __awaiter(this, void 0, void 0, function () {
            var element, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.isDisplayed()];
                    case 2:
                        status = _a.sent();
                        return [2 /*return*/, !status];
                }
            });
        });
    };
    /**
     * Get the enabled element status.
     * @param locator Element locator as string, could be a css locator.
    */
    BrowserView.prototype.elementIsEnabled = function (locator) {
        return __awaiter(this, void 0, void 0, function () {
            var element, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.isEnabled()];
                    case 2:
                        status = _a.sent();
                        return [2 /*return*/, status];
                }
            });
        });
    };
    /**
     * Get the clickable element status.
     * @param locator Element locator as string, could be a css locator.
    */
    BrowserView.prototype.elementIsClickable = function (locator) {
        return __awaiter(this, void 0, void 0, function () {
            var element, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $(locator)];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.isClickable()];
                    case 2:
                        status = _a.sent();
                        return [2 /*return*/, status];
                }
            });
        });
    };
    /**
     * Get the clickable element status by index.
     * @param locator Element locator as string, could be a css locator.
    */
    BrowserView.prototype.elementIsClickableByIndex = function (locator, index) {
        return __awaiter(this, void 0, void 0, function () {
            var element, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $$(locator)[index]];
                    case 1:
                        element = _a.sent();
                        return [4 /*yield*/, element.isClickable()];
                    case 2:
                        status = _a.sent();
                        return [2 /*return*/, status];
                }
            });
        });
    };
    return BrowserView;
}());
exports.BrowserView = BrowserView;
exports["default"] = new BrowserView();
